<?php
namespace Ep;

use Twig_Environment;
use Zend;
use Zend\ServiceManager\Factory\InvokableFactory;

/** @noinspection PhpUnnecessaryFullyQualifiedNameInspection */
return [
    'dependencies' => [
        'aliases' => [
            'currency_converter' => Currency\Converter::class,
            'db'                 => Zend\Db\Adapter\AdapterInterface::class,
            'mail'               => Zend\Mail\Transport\TransportInterface::class,
            'twig'               => Twig_Environment::class,
            'Twig'               => Twig_Environment::class,

            'app.base_url'          => Middleware\BaseUrl::class,
            'app.currency_exchange' => Middleware\ExchangeRates::class,
            'app.force_https'       => Middleware\ForceHttps::class,
            'app.force_www'         => Middleware\ForceWww::class,
        ],

        'factories' => [
            Currency\Adapter\AdapterInterface::class      => Currency\Adapter\AdapterFactory::class,
            Currency\Converter::class                     => Currency\ConverterFactory::class,
            Twig_Environment::class                       => View\TwigFactory::class,
            Zend\Db\Adapter\AdapterInterface::class       => Db\Adapter\AdapterServiceFactory::class,
            Zend\Mail\Protocol\SmtpPluginManager::class   => Zend\Mail\Protocol\SmtpPluginManagerFactory::class,
            Zend\Mail\Transport\TransportInterface::class => Mail\Transport\AbstractTransportFactory::class,
            Zend\View\Renderer\RendererInterface::class   => View\Renderer\TwigRendererFactory::class,
            Zend\View\HelperPluginManager::class          => View\HelperPluginManagerFactory::class,

            Middleware\BaseUrl::class       => InvokableFactory::class,
            Middleware\ExchangeRates::class => Currency\ConverterFactory::class,
            Middleware\ForceHttps::class    => InvokableFactory::class,
            Middleware\ForceWww::class      => InvokableFactory::class,
        ],
    ],
];