<?php
namespace Ep\Middleware;

use Interop\Http\Server\MiddlewareInterface;
use Interop\Http\Server\RequestHandlerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Zend\Diactoros\Response\RedirectResponse;

/**
 * Ako je trenutni request zatražen putem httpa, redirektamo na https.
 *
 * @package Ep\Middleware
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-framework
 */
class ForceHttps implements MiddlewareInterface
{
    /**
     * Ako je trenutni request zatražen putem httpa, redirektamo na https.
     *
     * @param ServerRequestInterface $request
     * @param RequestHandlerInterface $handler
     *
     * @return ResponseInterface
     */
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler)
    {
        $uri = $request->getUri();

        if ($uri->getScheme() !== 'https') {
            return new RedirectResponse($uri->withScheme('https'));
        }

        return $handler->handle($request);
    }
}