<?php
namespace EpTest\Middleware;

use Ep\Middleware\ForceHttps;
use PHPUnit\Framework\TestCase;
use Zend\Diactoros\Response;
use Zend\Diactoros\ServerRequestFactory;
use Zend\Diactoros\Uri;
use Zend\Stratigility\Delegate\CallableDelegateDecorator;

/**
 * Class ForceHttpsTest
 *
 * @package EpTest\Middleware
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-framework
 */
class ForceHttpsTest extends TestCase
{
    public function testWillRedirectIfHttp()
    {
        $request = ServerRequestFactory::fromGlobals()
            ->withUri(new Uri('http://ep-middleware.localhost/path/script.php?param=value'));

        $middleware = new ForceHttps();

        /** @noinspection PhpParamsInspection */
        $response = $middleware->process($request, new CallableDelegateDecorator(function() {}, new Response()));

        $this->assertEquals(
            'https://ep-middleware.localhost/path/script.php?param=value',
            $response->getHeaderLine('Location')
        );
    }

    public function testWillPassThroughWhenHttps()
    {
        $request = ServerRequestFactory::fromGlobals()
           ->withUri(new Uri('https://ep-middleware.localhost'));

        $middleware = new ForceHttps();

        /** @noinspection PhpParamsInspection */
        $middleware->process($request, new CallableDelegateDecorator(function() {
            $this->assertTrue(true);
        }, new Response()));
    }
}